/**
 * Getting Started with Capture.
 * 
 * Reading and displaying an image from an attached Capture device. 
 */

import processing.video.*;
import processing.serial.*;

double t = 0.0;
double tstart = 0.0; //Systemzeit

//double Kkrit = 0.005;
double Kkrit = 2.0;

ArrayList<double[]> merker = new ArrayList<double[]>(); 

Serial seriell;

boolean REGLER_AKTIV = false;

double Si = 0;
double abweichung =0;
double stellwert=0.0;

Capture cam;

int[] pix;

int CAMBREITE = 640; 
int CAMHOEHE  = 480; 

//               012345678901
byte[] puffer = "#+0000+0000$".getBytes();

void setzeAntrieb(int links, int rechts)
{
      if(links>9999)  links=9999;
      if(links<0)     links=0;
      if(rechts>9999) rechts=9999;
      if(rechts<0)    rechts=0;

      puffer[5] = (byte)(48+links%10);
      links/=10;
      puffer[4] = (byte)(48+links%10);
      links/=10;
      puffer[3] = (byte)(48+links%10);
      links/=10;
      puffer[2] = (byte)(48+links%10);
      
      puffer[10] = (byte)(48+rechts%10);
      rechts/=10;
      puffer[9] = (byte)(48+rechts%10);
      rechts/=10;
      puffer[8] = (byte)(48+rechts%10);
      rechts/=10;
      puffer[7] = (byte)(48+rechts%10);      
}


void setup() 
{
  //size(640, 480);
  size(1300, 700);

  String[] cameras = Capture.list();

  if (cameras == null) {
    println("Failed to retrieve the list of available cameras, will try the default...");
    cam = new Capture(this,CAMBREITE, CAMHOEHE);
  } if (cameras.length == 0) {
    println("There are no cameras available for capture.");
    exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(i+cameras[i]);
    }

    // The camera can be initialized directly using an element
    // from the array returned by list():
    cam = new Capture(this, cameras[0]);
    // Or, the settings can be defined based on the text in the list
    //cam = new Capture(this, 640, 480, "Built-in iSight", 30);
    
    // Start capturing the images from the camera
    cam.start();
  }
  
  
  seriell = new Serial(this, "/dev/ttyACM0", 9600);
//    frameRate(50);
  setzeAntrieb(0, 0); //0...9999 nutzbar: 3300...4500
  seriell.write(puffer);    
  frameRate(30);
}

void draw() 
{
  if(seriell==null)
      seriell = new Serial(this, "/dev/ttyACM0", 9600);
  
  //fill(0);
  //rect(0,0,displayWidth,displayHeight);

  if (cam.available() == true) 
  {
        cam.read();
    
//        image(cam,0,0);
        cam.updatePixels();
        pix = cam.pixels;
        int ii=0;
        
        double schwerpunkt  = 0;
        double summe_echtes_rot = 0;

        noStroke();
        for(int i=0;i<CAMHOEHE;i++)
        {

          
              for(int k=0;k<CAMBREITE;k++)
              {
                  int rot   = (int)red(pix[ii]);
                  int gruen = (int)green(pix[ii]);
                  int blau  = (int)blue(pix[ii]);
                  
                  int echtes_rot = rot -blau -gruen;
                  if(echtes_rot<0)
                      echtes_rot =0;
                  echtes_rot *=7;
                  if(echtes_rot>255)
                      echtes_rot = 255;
                  
  //                fill(echtes_rot,echtes_rot,echtes_rot);
                  
//                  rect(k*1+640,i*1,1,1);
                  
                  schwerpunkt  += k*echtes_rot;
                  summe_echtes_rot += echtes_rot;
                  
                  ii++;
              }
              if(summe_echtes_rot == 0.0)
              {
                 Si += (CAMBREITE/2);
              }
              else 
              {
                 Si += (schwerpunkt/summe_echtes_rot);
              }
        }
        Si /=CAMHOEHE;
        //println(Si);
    
  }
  stroke(255,0,0);
  line((float)Si+CAMBREITE,0,(float)Si+CAMBREITE,360);
  abweichung= (CAMBREITE/2) - Si;

  //P-Regler 
  //********
  fill(0);
  rect(0,490,displayWidth,300);
  
  noStroke();
  fill(255,100,100);
  textSize(40);

      if(REGLER_AKTIV==true)
      {
           if(abweichung<4.0 && abweichung>-4.0)
           {
                setzeAntrieb(0, 0); //0...9999 nutzbar: 3300...4500
                seriell.write(puffer);    
                println("Stellwert = "+0+" UNEMPF");
                text("Stellwert PWM: "+0+" UNEMPF",100,610);
           }
           else if(abweichung<0)
           {
                stellwert = -abweichung;
                stellwert*=Kkrit;
                stellwert+=2550;
                if(stellwert>9999) stellwert=9999;
                if(stellwert<0)    stellwert=0;
                setzeAntrieb((int)Math.round(stellwert), 0); //0...9999 nutzbar: 3300...4500
                seriell.write(puffer);    
                
                println("Stellwert = -"+stellwert);
                text("Stellwert PWM: -"+stellwert,100,610);
                
           }
           else
           {
                stellwert = abweichung;
                stellwert*=Kkrit;
                stellwert+=2550;
                if(stellwert>9999) stellwert=9999;
                if(stellwert<0)    stellwert=0;
                setzeAntrieb(0, (int)Math.round(stellwert)); //0...9999 nutzbar: 3300...4500
                seriell.write(puffer);    
                
                println("Stellwert = "+stellwert);
                text("Stellwert PWM: "+stellwert,100,610);
           }
           t   = 0.001 * (double)System.currentTimeMillis() - tstart;
           
           merker.add(new double[] {t,abweichung,(double)stellwert});
      }
      else
      {
                setzeAntrieb(0, 0); //0...9999 nutzbar: 3300...4500
                seriell.write(puffer);    
      }
/*
      while(seriell.available()>0)
      {
           print((char)seriell.read());
      }
*/
      if (keyPressed) 
      {
          if (key == '1') 
          {
               merker = new ArrayList<double[]>();
               tstart = 0.001 * (double)System.currentTimeMillis();
               REGLER_AKTIV = true;
          }
          else if (key == '2') 
          {
               REGLER_AKTIV = false;
               setzeAntrieb(0, 0); //0...9999 nutzbar: 3300...4500
               if(merker.size()>0)
               {
                   String[] arr = new String[merker.size()];
                   for(int i=0;i<arr.length;i++)
                   {
                        double[] d = merker.get(i);
                              //  t           abw          stell
                        arr[i] = d[0] + " " + d[1] + " " + d[2];
                   }
                   saveStrings("mat"+System.currentTimeMillis()+"_Kkrit"+Kkrit+".txt",arr);
               }
          }
      }  
  //********
  
  text("Regelabw. in Pixel: "+abweichung,100,530);
  
  println("Abweichung: "+ abweichung);
  // The following does the same as the above image() line, but 
  // is faster when just drawing the image without any additional 
  // resizing, transformations, or tint.
  //set(0, 0, cam);
}
